﻿var domWrapper = document.getElementById("dom-wrapper");


/**
* Textový uzel
*/
function executeExample1() {

    var txtNode = document.createTextNode("Křabou s těčuč. Clidě a něnipu hryp. Užráždlů z lkoup sryvůt pynou blipěstbu saš hli.");
    domWrapper.appendChild(txtNode);

}


/**
* HTML uzel
*/
function executeExample2() {

    var pNode = document.createElement("p");
    domWrapper.appendChild(pNode);

}



/**
* Sezam položek
*/
function executeExample3() {

    var ulElement = document.createElement("ul");

    for (var i = 0; i < 10; i++) {
        var liElement = document.createElement("li");

        liElement.className = "item";
        liElement.setAttribute("data-id", i);

        var txtElement = document.createTextNode((i + 1) + ". položka");
        liElement.appendChild(txtElement);
        ulElement.appendChild(liElement);
    }

    domWrapper.appendChild(ulElement);

}





/**
* Procházení DOM
*/
function executeExample4() {

    // Připravíme si HTML, které budeme procházet
    var html = [
        "<table>",
        "<thead>",
        "<tr>",
        "<th>Jméno</th><th>Věk</th><th>Město</th>",
        "</tr>",
        "</thead>",
        "<tbody>",
        "<tr>",
        "<td>Adam</td><td>32</td><td>Ostrava</td>",
        "</tr>",
        "<tr>",
        "<td>Tomáš</td><td>18</td><td>Nový Jičín</td>",
        "</tr>",
        "<tr>",
        "<td>Adéla</td><td>27</td><td>Odry</td>",
        "</tr>",
        "</tbody>",
        "</table>"
    ].join("");

    domWrapper.innerHTML = html;


    /*
    * Potomci elementu 'domWrapper'
    */
    console.log("Potomci elementu 'domWrapper':", domWrapper.childNodes);

    /*
    * Potomci elementu 'table'
    */
    console.log("Potomci elementu 'domWrapper':", domWrapper.childNodes[0].childNodes);

    /*
    * Nadřezený element elementu 'thead'
    */
    console.log("Nadřezený element elementu 'table':", domWrapper.childNodes[0].childNodes[0].parentNode);




    /*
    * Počet řádků v těle tabulky
    */
    var table = domWrapper.childNodes[0];

    // Dohledáme 'tbody' (v tomto případě víme, že jde o 2. potomek, ale uděláme obecnější řešení)
    var tBody = null;
    for (var i = 0; i < table.childNodes.length; i++) {
        if (table.childNodes[i].nodeName == "TBODY") {
            tBody = table.childNodes[i];
        }
    }
    // Předpokládáme, že element tbody v tabulce byl (nekontroluje se null)
    console.log("Počet řádků v těle tabulky:", tBody.childNodes.length);



    /*
     * První potomek
     */
    console.log("Prvním potomkem 'tbody' je:", tBody.firstChild);


    /*
     * Následník
     */
    console.log("Za prvním řádkem tabulky následuje:", tBody.firstChild.nextSibling);

    /*
     * Předchůdce
     */
    console.log("Před druhým řádkem tabulky je element:", tBody.childNodes[1].previousSibling);



    // Typy uzlů. vysvětlit:
    // https://developer.mozilla.org/en-US/docs/Web/API/Node.nodeType
}




/**
* Dynamicky generovaná upozornění
*/
function executeExample5() {

    // Kontejner pro zprávy
    var messageContainer = document.createElement("div");
    messageContainer.id = "message-container";
    document.body.appendChild(messageContainer);


    // Vygenerování a přidání zprávy
    function appendMessage(title, text) {
      
        // Obal zprávy
        var message = document.createElement("div");
        message.className = "flash-message";

        // Titulek
        var titleElement = document.createElement("strong");
        titleElement.innerText = title;
        message.appendChild(titleElement);

        // Odřádkování
        message.appendChild(document.createElement("br"));

        // Text zprávy
        message.appendChild(document.createTextNode(text));

        // Přidáme zprávu do kontejneru zpráv
        messageContainer.appendChild(message);

        // Po 5s zprávu odstraníme
        setTimeout(function () {
            messageContainer.removeChild(message);
        }, 5 * 1000);
    }


    // Připraví zprávu
    function prepareMessage(messageIndex) {
        // Náhodný timeout
        var timeout = Math.random() * (3 * 1000) + 1000;


        setTimeout(function () {

            var date = new Date();
            var dateStr = [date.getDate(), date.getMonth() + 1, date.getFullYear()].join(". ") + " " + [date.getHours(), date.getMinutes(), date.getSeconds()].join(":")

            appendMessage(
                "Zpráva " + messageIndex + "",
                "právě je " + dateStr
                );

            prepareMessage(messageIndex + 1);
        }, timeout);

    }

    // Spustíme
    prepareMessage(1);


    console.log("Chvíli strpení...");
}

